package tokml;

import com.Ostermiller.util.CSVParser;
import de.micromata.opengis.kml.v_2_2_0.Document;
import de.micromata.opengis.kml.v_2_2_0.Kml;
import de.micromata.opengis.kml.v_2_2_0.KmlFactory;
import de.micromata.opengis.kml.v_2_2_0.Placemark;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Application creates a KML file from a CSV file of Names and Addresseses
 * It uses the Google Geocoder to convert the address to a longitude/latitude pair.
 *
 * It uses the JAK library to create the KML file.
 * 
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {

        String location1 = null;
        String addresses[][] = null;

       
        
        try {
            CSVParser csv = new CSVParser(new FileReader("restaurants.csv"));
            try {
                    addresses = csv.getAllValues();
            } catch (IOException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }

        
        final Kml kml = KmlFactory.createKml();
        final Document document = kml.createAndSetDocument().withName("restaurants.kml").withOpen(true);

        // Display the parsed data
        for (int i=0; i<addresses.length; i++){

                System.out.println(addresses[i][0]);
                System.out.println(addresses[i][1]);
                System.out.println(addresses[i][2]);

        try {            
            location1 = Geocoder.getLocation(addresses[i][1]).toString();
        } catch (IOException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }

        final Placemark placemark1 = document.createAndAddPlacemark()
                                            .withName(addresses[i][0])
                                            .withDescription(addresses[i][1] + "<br>" + addresses[i][2]);
        placemark1.createAndSetPoint().addToCoordinates(location1);

        }

        try {
            kml.marshal(new File("Restaurants.kml"));
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

}
